'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _chalk;

function _load_chalk() {
  return _chalk = _interopRequireDefault(require('chalk'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Diff = function (_Command) {
  _inherits(Diff, _Command);

  function Diff() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Diff);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Diff.__proto__ || Object.getPrototypeOf(Diff)).call.apply(_ref, [this].concat(args))), _this), _this.name = 'diff [values...]', _this.description = `show diff between components files
  bit diff => compare all modified components to their model version
  bit diff [ids...] => compare the specified components against their modified states
  bit diff [id] [version] => compare the specified version to used or modified files
  bit diff [id] [version] [to_version] => compare the specified version files to to_version files
  the id can be used with wildcards (e.g. bit diff "utils/*")`, _this.alias = '', _this.opts = [['v', 'verbose', 'show a more verbose output when possible']], _this.loader = true, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Diff, [{
    key: 'action',
    value: function action(_ref2, _ref3) {
      var _ref4 = _slicedToArray(_ref2, 1),
          values = _ref4[0];

      var _ref3$verbose = _ref3.verbose,
          verbose = _ref3$verbose === undefined ? false : _ref3$verbose;

      return (0, (_consumer || _load_consumer()).diff)(values, verbose);
    }
  }, {
    key: 'report',
    value: function report(diffResults) {
      return diffResults.map(function (diffResult) {
        if (diffResult.hasDiff) {
          var titleStr = `showing diff for ${(_chalk || _load_chalk()).default.bold(diffResult.id.toStringWithoutVersion())}`;
          var titleSeparator = new Array(titleStr.length).fill('-').join('');
          var title = (_chalk || _load_chalk()).default.cyan(`${titleSeparator}\n${titleStr}\n${titleSeparator}`);
          // $FlowFixMe
          var filesWithDiff = diffResult.filesDiff.filter(function (file) {
            return file.diffOutput;
          });
          var files = filesWithDiff.map(function (fileDiff) {
            return fileDiff.diffOutput;
          }).join('\n');
          var fields = diffResult.fieldsDiff ? diffResult.fieldsDiff.map(function (field) {
            return field.diffOutput;
          }).join('\n') : '';
          return `${title}\n${files}\n${fields}`;
        }
        return `no diff for ${(_chalk || _load_chalk()).default.bold(diffResult.id.toString())}`;
      }).join('\n\n');
    }
  }]);

  return Diff;
}((_command || _load_command()).default);

exports.default = Diff;