'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _bluebird;

function _load_bluebird() {
  return _bluebird = require('bluebird');
}

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _yn;

function _load_yn() {
  return _yn = _interopRequireDefault(require('yn'));
}

var _command;

function _load_command() {
  return _command = _interopRequireDefault(require('../../command'));
}

var _consumer;

function _load_consumer() {
  return _consumer = require('../../../api/consumer');
}

var _removedComponents;

function _load_removedComponents() {
  return _removedComponents = require('../../../scope/removed-components');
}

var _removeTemplate;

function _load_removeTemplate() {
  return _removeTemplate = _interopRequireDefault(require('../../templates/remove-template'));
}

var _prompts;

function _load_prompts() {
  return _prompts = require('../../../prompts');
}

var _constants;

function _load_constants() {
  return _constants = require('../../../constants');
}

var _generalError;

function _load_generalError() {
  return _generalError = _interopRequireDefault(require('../../../error/general-error'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Remove = function (_Command) {
  _inherits(Remove, _Command);

  function Remove() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Remove);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Remove.__proto__ || Object.getPrototypeOf(Remove)).call.apply(_ref, [this].concat(args))), _this), _this.name = 'remove <ids...>', _this.description = `remove a component (local/remote)
  https://${(_constants || _load_constants()).BASE_DOCS_DOMAIN}/docs/removing-components.html
  the id can be used with wildcards (e.g. bit remove "utils/*")`, _this.alias = 'rm', _this.opts = [['f', 'force [boolean]', 'force remove (default = false)'], ['r', 'remote', 'remove a component from a remote scope'], ['t', 'track [boolean]', 'keep tracking component (default = false)'], ['d', 'delete-files [boolean]', 'delete local component files (authored components only. for imported components the files are always deleted)'], ['s', 'silent [boolean]', 'skip confirmation']], _this.loader = true, _this.migration = true, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Remove, [{
    key: 'action',
    value: function () {
      var _ref2 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(_ref3, _ref4) {
        var _ref5 = _slicedToArray(_ref3, 1),
            ids = _ref5[0];

        var _ref4$force = _ref4.force,
            force = _ref4$force === undefined ? false : _ref4$force,
            _ref4$remote = _ref4.remote,
            remote = _ref4$remote === undefined ? false : _ref4$remote,
            _ref4$track = _ref4.track,
            track = _ref4$track === undefined ? false : _ref4$track,
            _ref4$deleteFiles = _ref4.deleteFiles,
            deleteFiles = _ref4$deleteFiles === undefined ? false : _ref4$deleteFiles,
            _ref4$silent = _ref4.silent,
            silent = _ref4$silent === undefined ? false : _ref4$silent;
        var removePromptResult;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (silent) {
                  _context.next = 6;
                  break;
                }

                _context.next = 3;
                return (0, (_prompts || _load_prompts()).removePrompt)();

              case 3:
                removePromptResult = _context.sent;

                if ((0, (_yn || _load_yn()).default)(removePromptResult.shouldRemove)) {
                  _context.next = 6;
                  break;
                }

                throw new (_generalError || _load_generalError()).default('the operation has been canceled');

              case 6:
                return _context.abrupt('return', (0, (_consumer || _load_consumer()).remove)({ ids, remote, force, track, deleteFiles }));

              case 7:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function action(_x, _x2) {
        return _ref2.apply(this, arguments);
      }

      return action;
    }()
  }, {
    key: 'report',
    value: function report(_ref6) {
      var localResult = _ref6.localResult,
          _ref6$remoteResult = _ref6.remoteResult,
          remoteResult = _ref6$remoteResult === undefined ? [] : _ref6$remoteResult;

      return (0, (_removeTemplate || _load_removeTemplate()).default)(localResult, false) + this.paintArray(remoteResult);
    }
  }, {
    key: 'paintArray',
    value: function paintArray(removedObjectsArray) {
      // $FlowFixMe
      return removedObjectsArray.map(function (item) {
        return (0, (_removeTemplate || _load_removeTemplate()).default)(item, true);
      });
    }
  }]);

  return Remove;
}((_command || _load_command()).default);

exports.default = Remove;