'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.movePaths = undefined;

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _bluebird;

function _load_bluebird() {
  return _bluebird = require('bluebird');
}

var movePaths = exports.movePaths = function () {
  var _ref = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(consumer, _ref2) {
    var from = _ref2.from,
        to = _ref2.to;

    var fromExists, toExists, fromRelative, toRelative, fromAbsolute, toAbsolute, existingPath, changes, componentsIds, _ref3, components, nodeModuleLinker;

    return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            fromExists = (_fsExtra || _load_fsExtra()).default.existsSync(from);
            toExists = (_fsExtra || _load_fsExtra()).default.existsSync(to);

            if (!(fromExists && toExists)) {
              _context.next = 4;
              break;
            }

            throw new (_generalError || _load_generalError()).default(`unable to move because both paths from (${from}) and to (${to}) already exist`);

          case 4:
            if (!(!fromExists && !toExists)) {
              _context.next = 6;
              break;
            }

            throw new (_generalError || _load_generalError()).default(`both paths from (${from}) and to (${to}) do not exist`);

          case 6:
            fromRelative = consumer.getPathRelativeToConsumer(from);
            toRelative = consumer.getPathRelativeToConsumer(to);
            fromAbsolute = consumer.toAbsolutePath(fromRelative);
            toAbsolute = consumer.toAbsolutePath(toRelative);
            existingPath = fromExists ? fromAbsolute : toAbsolute;
            changes = consumer.bitMap.updatePathLocation(fromRelative, toRelative, existingPath);

            if (fromExists && !toExists) {
              // user would like to physically move the file. Otherwise (!fromExists and toExists), user would like to only update bit.map
              (0, (_moveSync || _load_moveSync()).default)(fromAbsolute, toAbsolute);
            }

            if ((_ramda || _load_ramda()).default.isEmpty(changes)) {
              _context.next = 26;
              break;
            }

            componentsIds = changes.map(function (c) {
              return c.id;
            });
            _context.next = 17;
            return consumer.loadComponents((_bitIds || _load_bitIds()).default.fromArray(componentsIds));

          case 17:
            _ref3 = _context.sent;
            components = _ref3.components;
            _context.next = 21;
            return (_packageJson || _load_packageJson()).addComponentsToRoot(consumer, components);

          case 21:
            nodeModuleLinker = new (_links || _load_links()).NodeModuleLinker(components, consumer);
            _context.next = 24;
            return nodeModuleLinker.link();

          case 24:
            _context.next = 26;
            return (0, (_links || _load_links()).reLinkDependents)(consumer, components);

          case 26:
            return _context.abrupt('return', changes);

          case 27:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function movePaths(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

exports.moveExistingComponent = moveExistingComponent;

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _links;

function _load_links() {
  return _links = require('../../links');
}

var _packageJson;

function _load_packageJson() {
  return _packageJson = _interopRequireWildcard(require('../component/package-json'));
}

var _generalError;

function _load_generalError() {
  return _generalError = _interopRequireDefault(require('../../error/general-error'));
}

var _moveSync;

function _load_moveSync() {
  return _moveSync = _interopRequireDefault(require('../../utils/fs/move-sync'));
}

var _removePath;

function _load_removePath() {
  return _removePath = _interopRequireDefault(require('../component/sources/remove-path'));
}

var _bitIds;

function _load_bitIds() {
  return _bitIds = _interopRequireDefault(require('../../bit-id/bit-ids'));
}

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function moveExistingComponent(consumer, component, oldPath, newPath) {
  if ((_fsExtra || _load_fsExtra()).default.existsSync(newPath)) {
    throw new (_generalError || _load_generalError()).default(`could not move the component ${component.id.toString()} from ${oldPath} to ${newPath} as the destination path already exists`);
  }
  var componentMap = consumer.bitMap.getComponent(component.id);
  var oldPathRelative = consumer.getPathRelativeToConsumer(oldPath);
  var newPathRelative = consumer.getPathRelativeToConsumer(newPath);
  componentMap.updateDirLocation(oldPathRelative, newPathRelative);
  component.dataToPersist.files.forEach(function (file) {
    var newBase = file.base.replace(oldPathRelative, newPathRelative);
    file.updatePaths({ newBase });
  });
  component.dataToPersist.removePath(new (_removePath || _load_removePath()).default(oldPathRelative));
  component.writtenPath = newPathRelative;
}