'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.errorReportingPrompt = exports.analyticsPrompt = exports.resolveConflictPrompt = exports.removePrompt = exports.userpass = exports.passphrase = undefined;

var _passphrase;

function _load_passphrase() {
  return _passphrase = _interopRequireDefault(require('./schemas/passphrase'));
}

var _userPassword;

function _load_userPassword() {
  return _userPassword = _interopRequireDefault(require('./schemas/user-password'));
}

var _remoteRemove;

function _load_remoteRemove() {
  return _remoteRemove = _interopRequireDefault(require('./schemas/remote-remove'));
}

var _resolveConflict;

function _load_resolveConflict() {
  return _resolveConflict = _interopRequireDefault(require('./schemas/resolve-conflict'));
}

var _analyticsReporting;

function _load_analyticsReporting() {
  return _analyticsReporting = _interopRequireDefault(require('./schemas/analytics-reporting'));
}

var _errorReporting;

function _load_errorReporting() {
  return _errorReporting = _interopRequireDefault(require('./schemas/error-reporting'));
}

var _prompt;

function _load_prompt() {
  return _prompt = _interopRequireDefault(require('./prompt'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var passphrase = (0, (_prompt || _load_prompt()).default)((_passphrase || _load_passphrase()).default);
var userpass = (0, (_prompt || _load_prompt()).default)((_userPassword || _load_userPassword()).default);
var removePrompt = (0, (_prompt || _load_prompt()).default)((_remoteRemove || _load_remoteRemove()).default);
var resolveConflictPrompt = (0, (_prompt || _load_prompt()).default)((_resolveConflict || _load_resolveConflict()).default);
var analyticsPrompt = (0, (_prompt || _load_prompt()).default)((_analyticsReporting || _load_analyticsReporting()).default);
var errorReportingPrompt = (0, (_prompt || _load_prompt()).default)((_errorReporting || _load_errorReporting()).default);

exports.passphrase = passphrase;
exports.userpass = userpass;
exports.removePrompt = removePrompt;
exports.resolveConflictPrompt = resolveConflictPrompt;
exports.analyticsPrompt = analyticsPrompt;
exports.errorReportingPrompt = errorReportingPrompt;