'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _object;

function _load_object() {
  return _object = _interopRequireDefault(require('../objects/object'));
}

var _utils;

function _load_utils() {
  return _utils = require('../../utils');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../bit-id');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Symlink = function (_BitObject) {
  _inherits(Symlink, _BitObject);

  function Symlink(props) {
    _classCallCheck(this, Symlink);

    var _this = _possibleConstructorReturn(this, (Symlink.__proto__ || Object.getPrototypeOf(Symlink)).call(this));

    _this.scope = props.scope;
    _this.name = props.name;
    _this.realScope = props.realScope;
    return _this;
  }

  _createClass(Symlink, [{
    key: 'id',
    value: function id() {
      return this.name;
    }
  }, {
    key: 'getRealComponentId',
    value: function getRealComponentId() {
      return new (_bitId || _load_bitId()).BitId({ scope: this.realScope, name: this.name });
    }
  }, {
    key: 'toObject',
    value: function toObject() {
      return {
        scope: this.scope,
        name: this.name,
        realScope: this.realScope
      };
    }
  }, {
    key: 'toBitId',
    value: function toBitId() {
      return new (_bitId || _load_bitId()).BitId({ name: this.name });
    }
  }, {
    key: 'toBuffer',
    value: function toBuffer(pretty) {
      var args = (0, (_utils || _load_utils()).getStringifyArgs)(pretty);
      return Buffer.from(JSON.stringify.apply(JSON, [this.toObject()].concat(_toConsumableArray(args))));
    }
  }], [{
    key: 'parse',
    value: function parse(contents) {
      var rawContent = JSON.parse(contents);
      if (rawContent.box) rawContent.name = `${rawContent.box}/${rawContent.name}`;
      return Symlink.from(rawContent);
    }
  }, {
    key: 'from',
    value: function from(props) {
      return new Symlink(props);
    }
  }]);

  return Symlink;
}((_object || _load_object()).default);

exports.default = Symlink;