'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _bluebird;

function _load_bluebird() {
  return _bluebird = require('bluebird');
}

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _componentDependencies;

function _load_componentDependencies() {
  return _componentDependencies = _interopRequireDefault(require('./component-dependencies'));
}

var _componentVersion;

function _load_componentVersion() {
  return _componentVersion = _interopRequireDefault(require('./component-version'));
}

var _componentObjects;

function _load_componentObjects() {
  return _componentObjects = _interopRequireDefault(require('./component-objects'));
}

var _repository;

function _load_repository() {
  return _repository = _interopRequireDefault(require('./objects/repository'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var VersionDependencies = function () {
  function VersionDependencies(component, dependencies, devDependencies, compilerDependencies, testerDependencies, sourceScope) {
    _classCallCheck(this, VersionDependencies);

    this.component = component;
    this.dependencies = dependencies;
    this.devDependencies = devDependencies;
    this.compilerDependencies = compilerDependencies;
    this.testerDependencies = testerDependencies;
    this.allDependencies = [].concat(_toConsumableArray(this.dependencies), _toConsumableArray(this.devDependencies), _toConsumableArray(this.compilerDependencies), _toConsumableArray(this.testerDependencies));
    this.sourceScope = sourceScope;
  }

  _createClass(VersionDependencies, [{
    key: 'toConsumer',
    value: function () {
      var _ref = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(repo, manipulateDirData) {
        var depToConsumer, dependenciesP, devDependenciesP, compilerDependenciesP, testerDependenciesP, componentP, _ref2, _ref3, component, dependencies, devDependencies, compilerDependencies, testerDependencies;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                depToConsumer = function depToConsumer(dep) {
                  return dep.toConsumer(repo, manipulateDirData);
                };

                dependenciesP = Promise.all(this.dependencies.map(depToConsumer));
                devDependenciesP = Promise.all(this.devDependencies.map(depToConsumer));
                compilerDependenciesP = Promise.all(this.compilerDependencies.map(depToConsumer));
                testerDependenciesP = Promise.all(this.testerDependencies.map(depToConsumer));
                componentP = this.component.toConsumer(repo, manipulateDirData);
                _context.next = 8;
                return Promise.all([componentP, dependenciesP, devDependenciesP, compilerDependenciesP, testerDependenciesP]);

              case 8:
                _ref2 = _context.sent;
                _ref3 = _slicedToArray(_ref2, 5);
                component = _ref3[0];
                dependencies = _ref3[1];
                devDependencies = _ref3[2];
                compilerDependencies = _ref3[3];
                testerDependencies = _ref3[4];
                return _context.abrupt('return', new (_componentDependencies || _load_componentDependencies()).default({
                  component,
                  dependencies,
                  devDependencies,
                  compilerDependencies,
                  testerDependencies
                }));

              case 16:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function toConsumer(_x, _x2) {
        return _ref.apply(this, arguments);
      }

      return toConsumer;
    }()
  }, {
    key: 'toObjects',
    value: function toObjects(repo) {
      var depsP = Promise.all(this.allDependencies.map(function (dep) {
        return dep.toObjects(repo);
      }));
      var compP = this.component.toObjects(repo);

      return Promise.all([compP, depsP]).then(function (_ref4) {
        var _ref5 = _slicedToArray(_ref4, 2),
            component = _ref5[0],
            dependencies = _ref5[1];

        var flattened = dependencies.reduce(function (array, compObjects) {
          array.push.apply(array, _toConsumableArray(compObjects.objects.concat([compObjects.component])));
          return array;
        }, []);

        return new (_componentObjects || _load_componentObjects()).default(component.component, flattened.concat(component.objects));
      });
    }
  }]);

  return VersionDependencies;
}();

exports.default = VersionDependencies;