'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _bluebird;

function _load_bluebird() {
  return _bluebird = require('bluebird');
}

var _execa;

function _load_execa() {
  return _execa = _interopRequireDefault(require('execa'));
}

var _gitNotFound;

function _load_gitNotFound() {
  return _gitNotFound = _interopRequireDefault(require('./git/exceptions/git-not-found'));
}

var _gitExecutable;

function _load_gitExecutable() {
  return _gitExecutable = _interopRequireDefault(require('./git/git-executable'));
}

var _logger;

function _load_logger() {
  return _logger = _interopRequireDefault(require('../logger/logger'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * get diff between files using git diff command
 */
exports.default = function () {
  var _ref = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(fileA, fileB) {
    var colors = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
    var params, gitExecutablePath, result;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            params = ['diff'];

            params.push('--no-index'); // ignores the working tree (in case the project is managed by git)
            if (colors) params.push('--color');
            params.push(fileA);
            params.push(fileB);
            gitExecutablePath = (0, (_gitExecutable || _load_gitExecutable()).default)();
            _context.prev = 6;
            _context.next = 9;
            return (0, (_execa || _load_execa()).default)(gitExecutablePath, params);

          case 9:
            result = _context.sent;
            return _context.abrupt('return', result.stdout);

          case 13:
            _context.prev = 13;
            _context.t0 = _context['catch'](6);

            if (!(_context.t0.code && Number.isInteger(_context.t0.code) && _context.t0.stdout)) {
              _context.next = 17;
              break;
            }

            return _context.abrupt('return', _context.t0.stdout);

          case 17:
            if (!(_context.t0.code === 'ENOENT')) {
              _context.next = 20;
              break;
            }

            (_logger || _load_logger()).default.error(`failed running Git at ${gitExecutablePath}. full command: ${_context.t0.cmd}`);
            throw new (_gitNotFound || _load_gitNotFound()).default(gitExecutablePath, _context.t0);

          case 20:
            throw _context.t0;

          case 21:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[6, 13]]);
  }));

  function diffFiles(_x, _x2) {
    return _ref.apply(this, arguments);
  }

  return diffFiles;
}();