'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _bluebird;

function _load_bluebird() {
  return _bluebird = require('bluebird');
}

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _logger;

function _load_logger() {
  return _logger = _interopRequireDefault(require('../logger/logger'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(path) {
    var propogateDirs = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

    var res, _pathlib$parse, dir, files;

    return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (_fsExtra || _load_fsExtra()).default.unlink(path);

          case 2:
            res = _context.sent;

            if (propogateDirs) {
              _context.next = 5;
              break;
            }

            return _context.abrupt('return', res);

          case 5:
            _pathlib$parse = (_path || _load_path()).default.parse(path), dir = _pathlib$parse.dir;
            _context.next = 8;
            return (_fsExtra || _load_fsExtra()).default.readdir(dir);

          case 8:
            files = _context.sent;

            if (!(files.length !== 0)) {
              _context.next = 11;
              break;
            }

            return _context.abrupt('return', res);

          case 11:
            (_logger || _load_logger()).default.info(`fs-remove-file, deleting empty directory ${dir}`);
            _context.next = 14;
            return (_fsExtra || _load_fsExtra()).default.remove(dir);

          case 14:
            return _context.abrupt('return', res);

          case 15:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function removeFile(_x) {
    return _ref.apply(this, arguments);
  }

  return removeFile;
}();