'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _bluebird;

function _load_bluebird() {
  return _bluebird = require('bluebird');
}

var _path;

function _load_path() {
  return _path = _interopRequireDefault(require('path'));
}

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _pMapSeries;

function _load_pMapSeries() {
  return _pMapSeries = _interopRequireDefault(require('p-map-series'));
}

var _removeEmptyDir;

function _load_removeEmptyDir() {
  return _removeEmptyDir = _interopRequireDefault(require('./remove-empty-dir'));
}

var _logger;

function _load_logger() {
  return _logger = _interopRequireDefault(require('../../logger/logger'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * This function will remove the list of files from fs
 * Then go to the folder of each file and remove it as well if it's empty
 */
exports.default = function () {
  var _ref = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(filesPaths) {
    var dirs, deleteP, sortedDirs;
    return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            dirs = filesPaths.map(function (filePath) {
              return (_path || _load_path()).default.dirname(filePath);
            });
            deleteP = filesPaths.map(function (filePath) {
              return (_fsExtra || _load_fsExtra()).default.remove(filePath);
            });

            (_logger || _load_logger()).default.info(`remove-files-and-empty-dirs-recursively deleting the following paths: ${filesPaths.join(', ')}`);
            _context.next = 5;
            return Promise.all(deleteP);

          case 5:
            // Sorting it to make sure we will delete the inner dirs first
            sortedDirs = dirs.sort().reverse();
            _context.next = 8;
            return (0, (_pMapSeries || _load_pMapSeries()).default)(sortedDirs, function (dir) {
              return (0, (_removeEmptyDir || _load_removeEmptyDir()).default)(dir);
            });

          case 8:
            return _context.abrupt('return', true);

          case 9:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function removeFilesAndEmptyDirsRecursively(_x) {
    return _ref.apply(this, arguments);
  }

  return removeFilesAndEmptyDirsRecursively;
}();