'use strict';

var _chai;

function _load_chai() {
  return _chai = require('chai');
}

var _isValidIdChunk;

function _load_isValidIdChunk() {
  return _isValidIdChunk = _interopRequireDefault(require('./is-valid-id-chunk'));
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('isValidIdChunk', function () {
  it('should disallow non string inputs', function () {
    (0, (_chai || _load_chai()).expect)((0, (_isValidIdChunk || _load_isValidIdChunk()).default)(123)).to.be.false;
    (0, (_chai || _load_chai()).expect)((0, (_isValidIdChunk || _load_isValidIdChunk()).default)(123), true).to.be.false;
  });
  it('should allow a string that consist of small letters', function () {
    (0, (_chai || _load_chai()).expect)((0, (_isValidIdChunk || _load_isValidIdChunk()).default)('abc')).to.be.true;
    (0, (_chai || _load_chai()).expect)((0, (_isValidIdChunk || _load_isValidIdChunk()).default)('abc', true)).to.be.true;
  });
  it('should disallow a string that has a capital letter', function () {
    (0, (_chai || _load_chai()).expect)((0, (_isValidIdChunk || _load_isValidIdChunk()).default)('Abc')).to.be.false;
    (0, (_chai || _load_chai()).expect)((0, (_isValidIdChunk || _load_isValidIdChunk()).default)('Abc', true)).to.be.false;
  });
});